Khronos Public Bugzilla
Bug 785 - Translator from OpenCL-kernel to safe WebCL-Kernel
Translator from OpenCL-kernel to safe WebCL-Kernel
Status: RESOLVED FIXED
Product: WebCL
Classification: Unclassified
Component: Validator and Translator
1.0
All All
: P3 normal
: ---
Assigned To: WebCL Mailing List
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2013-02-06 10:18 PST by steven eliuk
Modified: 2013-07-24 12:04 PDT (History)
1 user (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description steven eliuk 2013-02-06 10:18:54 PST
During the last F2F the group identified the need for a utility to convert
OpenCL-Kernels to WebCL-kernels.

I am currently evaluating SNU OpenCL 1.0 OpenSource version to see if we can
leverage the front end for this utility.
Comment 1 steven eliuk 2013-02-28 10:40:15 PST
Question for the community,

During translation when one encounters a kernel identifier with a length > 255 there are two options:
-change the name to a unique 'in-spec' identifier. 
-or simply stop the translation and notify through verbose output in the logfile and stdout concerning the problem.

In both situations the logfile will contain information concerning the identifier length being greater than 255. In the first, one could detail the change.

Personally, I like the ability to replace the kernel identifier and continue. On the other hand, changing code could lead to problems. 

Thank you for the input,

Regards,
Comment 2 Tomi Aarnio 2013-03-18 07:03:55 PDT
(In reply to comment #1)

> During translation when one encounters a kernel identifier with a length >
> 255 there are two options:
> -change the name to a unique 'in-spec' identifier. 
> -or simply stop the translation and notify through verbose output in the
> logfile and stdout concerning the problem.

I'd rather play it safe and reject the kernel.
Comment 3 steven eliuk 2013-06-12 11:11:30 PDT
Anthony Liot [ACTSKU] is working on an OpenCL to WebCL tool that makes use of emscripten for translation.

Check it out here,
https://github.com/wolfviking0/webcl-emscripten


We look forward to speaking more with Anthony the week of June 17-21 when his schedule is more reasonable.
Comment 4 steven eliuk 2013-06-27 13:24:29 PDT
Reaching out to Anthony it looks like we just need to iron out the requirements and get to work,

Once I have more details concerning the sequencing of to-do items I will update this bug,
Comment 5 steven eliuk 2013-07-12 09:53:11 PDT
There has been a lot of progress recently on emscripten / webcl translator found through the following link,
https://github.com/wolfviking0/webcl-emscripten

Specifically, there are a couple basic helloworld translations and a slightly more complicated convolution examples that have been successfully converted to both {webkit, firefox} / webcl implementations. There are some slight differences in the firefox implementation given there is no cl-gl interop and the implementation is slightly behind the WebCL WD.

Please take a look at the code and I will update this bug periodically with status updates...
Comment 6 steven eliuk 2013-07-24 12:04:45 PDT
The initial kernel translator was completed many months ago, the focus is now on OpenCL C++ translation to WebCK/JS using emscripten. Therefore, this bug is outdated and considered resolved.